/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-rtabmap-ros-0.8.12-0quantal-20150806-0419/msg/Graph.msg
 *
 */


#ifndef RTABMAP_ROS_MESSAGE_GRAPH_H
#define RTABMAP_ROS_MESSAGE_GRAPH_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <std_msgs/Header.h>
#include <geometry_msgs/Transform.h>
#include <rtabmap_ros/UserData.h>
#include <geometry_msgs/Pose.h>
#include <rtabmap_ros/Link.h>

namespace rtabmap_ros
{
template <class ContainerAllocator>
struct Graph_
{
  typedef Graph_<ContainerAllocator> Type;

  Graph_()
    : header()
    , mapToOdom()
    , nodeIds()
    , mapIds()
    , labels()
    , stamps()
    , userDatas()
    , poses()
    , links()  {
    }
  Graph_(const ContainerAllocator& _alloc)
    : header(_alloc)
    , mapToOdom(_alloc)
    , nodeIds(_alloc)
    , mapIds(_alloc)
    , labels(_alloc)
    , stamps(_alloc)
    , userDatas(_alloc)
    , poses(_alloc)
    , links(_alloc)  {
    }



   typedef  ::std_msgs::Header_<ContainerAllocator>  _header_type;
  _header_type header;

   typedef  ::geometry_msgs::Transform_<ContainerAllocator>  _mapToOdom_type;
  _mapToOdom_type mapToOdom;

   typedef std::vector<int32_t, typename ContainerAllocator::template rebind<int32_t>::other >  _nodeIds_type;
  _nodeIds_type nodeIds;

   typedef std::vector<int32_t, typename ContainerAllocator::template rebind<int32_t>::other >  _mapIds_type;
  _mapIds_type mapIds;

   typedef std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > , typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::other >  _labels_type;
  _labels_type labels;

   typedef std::vector<double, typename ContainerAllocator::template rebind<double>::other >  _stamps_type;
  _stamps_type stamps;

   typedef std::vector< ::rtabmap_ros::UserData_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::rtabmap_ros::UserData_<ContainerAllocator> >::other >  _userDatas_type;
  _userDatas_type userDatas;

   typedef std::vector< ::geometry_msgs::Pose_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::geometry_msgs::Pose_<ContainerAllocator> >::other >  _poses_type;
  _poses_type poses;

   typedef std::vector< ::rtabmap_ros::Link_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::rtabmap_ros::Link_<ContainerAllocator> >::other >  _links_type;
  _links_type links;




  typedef boost::shared_ptr< ::rtabmap_ros::Graph_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::rtabmap_ros::Graph_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct Graph_

typedef ::rtabmap_ros::Graph_<std::allocator<void> > Graph;

typedef boost::shared_ptr< ::rtabmap_ros::Graph > GraphPtr;
typedef boost::shared_ptr< ::rtabmap_ros::Graph const> GraphConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::rtabmap_ros::Graph_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::rtabmap_ros::Graph_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace rtabmap_ros

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': True}
// {'sensor_msgs': ['/opt/ros/hydro/share/sensor_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'rtabmap_ros': ['/tmp/buildd/ros-hydro-rtabmap-ros-0.8.12-0quantal-20150806-0419/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::rtabmap_ros::Graph_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::rtabmap_ros::Graph_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::rtabmap_ros::Graph_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::rtabmap_ros::Graph_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::rtabmap_ros::Graph_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::rtabmap_ros::Graph_<ContainerAllocator> const>
  : TrueType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::rtabmap_ros::Graph_<ContainerAllocator> >
{
  static const char* value()
  {
    return "0b30b6d3dc761ce76944a16428186dd0";
  }

  static const char* value(const ::rtabmap_ros::Graph_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x0b30b6d3dc761ce7ULL;
  static const uint64_t static_value2 = 0x6944a16428186dd0ULL;
};

template<class ContainerAllocator>
struct DataType< ::rtabmap_ros::Graph_<ContainerAllocator> >
{
  static const char* value()
  {
    return "rtabmap_ros/Graph";
  }

  static const char* value(const ::rtabmap_ros::Graph_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::rtabmap_ros::Graph_<ContainerAllocator> >
{
  static const char* value()
  {
    return "\n\
Header header\n\
\n\
##\n\
# /map to /odom transform\n\
# Always identity when the graph is optimized from the latest pose.\n\
##\n\
geometry_msgs/Transform mapToOdom\n\
\n\
##\n\
# The nodes\n\
# std::map<nodeId, mapId>\n\
int32[] nodeIds\n\
int32[] mapIds\n\
string[] labels\n\
float64[] stamps\n\
UserData[] userDatas\n\
\n\
# std::map<nodeId, Pose>\n\
geometry_msgs/Pose[] poses\n\
\n\
##\n\
# The links\n\
##\n\
Link[] links\n\
\n\
\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.secs: seconds (stamp_secs) since epoch\n\
# * stamp.nsecs: nanoseconds since stamp_secs\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Transform\n\
# This represents the transform between two coordinate frames in free space.\n\
\n\
Vector3 translation\n\
Quaternion rotation\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Vector3\n\
# This represents a vector in free space. \n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
================================================================================\n\
MSG: geometry_msgs/Quaternion\n\
# This represents an orientation in free space in quaternion form.\n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
float64 w\n\
\n\
================================================================================\n\
MSG: rtabmap_ros/UserData\n\
\n\
uint8[] data\n\
================================================================================\n\
MSG: geometry_msgs/Pose\n\
# A representation of pose in free space, composed of postion and orientation. \n\
Point position\n\
Quaternion orientation\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Point\n\
# This contains the position of a point in free space\n\
float64 x\n\
float64 y\n\
float64 z\n\
\n\
================================================================================\n\
MSG: rtabmap_ros/Link\n\
#class rtabmap::Link\n\
#{\n\
#   int from;\n\
#   int to;\n\
#   Type type;\n\
#   Transform transform;\n\
#   float variance;\n\
#}\n\
\n\
int32 fromId\n\
int32 toId\n\
int32 type\n\
geometry_msgs/Transform transform\n\
float32 rotVariance\n\
float32 transVariance\n\
";
  }

  static const char* value(const ::rtabmap_ros::Graph_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::rtabmap_ros::Graph_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.header);
      stream.next(m.mapToOdom);
      stream.next(m.nodeIds);
      stream.next(m.mapIds);
      stream.next(m.labels);
      stream.next(m.stamps);
      stream.next(m.userDatas);
      stream.next(m.poses);
      stream.next(m.links);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct Graph_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::rtabmap_ros::Graph_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::rtabmap_ros::Graph_<ContainerAllocator>& v)
  {
    s << indent << "header: ";
    s << std::endl;
    Printer< ::std_msgs::Header_<ContainerAllocator> >::stream(s, indent + "  ", v.header);
    s << indent << "mapToOdom: ";
    s << std::endl;
    Printer< ::geometry_msgs::Transform_<ContainerAllocator> >::stream(s, indent + "  ", v.mapToOdom);
    s << indent << "nodeIds[]" << std::endl;
    for (size_t i = 0; i < v.nodeIds.size(); ++i)
    {
      s << indent << "  nodeIds[" << i << "]: ";
      Printer<int32_t>::stream(s, indent + "  ", v.nodeIds[i]);
    }
    s << indent << "mapIds[]" << std::endl;
    for (size_t i = 0; i < v.mapIds.size(); ++i)
    {
      s << indent << "  mapIds[" << i << "]: ";
      Printer<int32_t>::stream(s, indent + "  ", v.mapIds[i]);
    }
    s << indent << "labels[]" << std::endl;
    for (size_t i = 0; i < v.labels.size(); ++i)
    {
      s << indent << "  labels[" << i << "]: ";
      Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.labels[i]);
    }
    s << indent << "stamps[]" << std::endl;
    for (size_t i = 0; i < v.stamps.size(); ++i)
    {
      s << indent << "  stamps[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.stamps[i]);
    }
    s << indent << "userDatas[]" << std::endl;
    for (size_t i = 0; i < v.userDatas.size(); ++i)
    {
      s << indent << "  userDatas[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::rtabmap_ros::UserData_<ContainerAllocator> >::stream(s, indent + "    ", v.userDatas[i]);
    }
    s << indent << "poses[]" << std::endl;
    for (size_t i = 0; i < v.poses.size(); ++i)
    {
      s << indent << "  poses[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::geometry_msgs::Pose_<ContainerAllocator> >::stream(s, indent + "    ", v.poses[i]);
    }
    s << indent << "links[]" << std::endl;
    for (size_t i = 0; i < v.links.size(); ++i)
    {
      s << indent << "  links[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::rtabmap_ros::Link_<ContainerAllocator> >::stream(s, indent + "    ", v.links[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // RTABMAP_ROS_MESSAGE_GRAPH_H
